﻿using System.Drawing;
using System.Linq;

namespace NTERA.Console
{
	public class ButtonTextRenderItem : BaseRenderItem
	{
		public static Font Font { get; set; } = new Font("MS UI Gothic", 12); //new Font("Arial", 12);

		public static SolidBrush TextBrush = new SolidBrush(Color.White);

		public static SolidBrush BackingHighlightBrush = new SolidBrush(Color.DarkRed);

		public static SolidBrush SelectedBackingHighlightBrush = new SolidBrush(Color.Yellow);

		public string Text { get; set; }

		public CharacterRange[] ButtonRanges { get; set; }

		public ButtonTextRenderItem(string text, CharacterRange[] buttonRanges)
		{
			Text = text;
			ButtonRanges = buttonRanges;
		}

		public override void Render(Graphics graphics, Rectangle renderArea, Point mousePointer)
		{
			StringFormat stringFormat1 = new StringFormat();
			stringFormat1.SetMeasurableCharacterRanges(ButtonRanges);

			UpdateRegions = graphics.MeasureCharacterRanges(Text, Font, renderArea, stringFormat1)
				.Select(x => Rectangle.Round(x.GetBounds(graphics))).ToArray();

			foreach (var region in UpdateRegions)
			{
				Brush brush = region.Contains(mousePointer)
					? SelectedBackingHighlightBrush
					: BackingHighlightBrush;

				graphics.FillRectangle(brush, region);
			}

			graphics.DrawString(Text, Font, TextBrush, renderArea);
		}
	}
}