﻿using MinorShift.Emuera;
using MinorShift.Emuera.GameProc;

namespace NTERA.Interop
{
	public class GameInstance
	{
		private Process emuera;

		public void Initialize(IConsole console)
		{
			GlobalStatic.Console = console;
			//GlobalStatic.MainWindow = _window;
			emuera = new Process(console);
			GlobalStatic.Process = emuera;
			//ClearDisplay();
			if (!emuera.Initialize())
			{
				//state = ConsoleState.Error;
				//OutputLog(null);
				//PrintFlush(false);
				//RefreshStrings(true);
				return;
			}
			CallEmueraProgram("");
			//RefreshStrings(true);
		}

		public void GiveInput(string input)
		{
			InputRequest currentRequest = GlobalStatic.Console.CurrentRequest;

			if (GlobalStatic.Console.CurrentRequest != null)
			{
				switch (currentRequest.InputType)
				{
					case InputType.IntValue:
						long inputValue;

						if (string.IsNullOrEmpty(input) && currentRequest.HasDefValue)// && !IsRunningTimer)
						{
							inputValue = currentRequest.DefIntValue;
							input = inputValue.ToString();
						}
						else if (!long.TryParse(input, out inputValue))
						{
							break;
						}
						if (currentRequest.IsSystemInput)
							emuera.InputSystemInteger(inputValue);
						else
							emuera.InputInteger(inputValue);
						break;
					case InputType.StrValue:
						if (string.IsNullOrEmpty(input) && currentRequest.HasDefValue)// && !IsRunningTimer)
							input = currentRequest.DefStrValue;

						emuera.InputString(input ?? "");
						break;
				}
			}

			GlobalStatic.Console.GiveInput(input);
		}

		private void CallEmueraProgram(string str)
		{
			//if (!DoInputToEmueraProgram(str))
			//	return;
			//if (state == ConsoleState.Error)
			//	return;
			//state = ConsoleState.Running;
			emuera.DoScript();
//			if (state == ConsoleState.Running)
//			{
////RunningならProcessは処理を継続するべき
//				state = ConsoleState.Error;
//				PrintError("Emuera error: Unable to determine program status");
//			}
			//if (state == ConsoleState.Error && !noOutputLog)
			//	OutputLog(Program.ExeDir + "emuera.log");
			//PrintFlush(false);
			////1819 Refreshは呼び出し側で行う
			////RefreshStrings(false);
			//NewGeneration();
		}
	}
}
